/*
 * Copyright (C) 2013 the original author or authors.
 * See the notice.md file distributed with this work for additional
 * information regarding copyright ownership.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.google.code.vaadin.internal.jsr250;

import com.google.code.vaadin.application.AbstractMVPApplicationModule;
import com.google.inject.AbstractModule;
import com.mycila.inject.jsr250.Jsr250;

/**
 * JSR-250 support module. Default implementation is {@link Jsr250}.
 *
 * @author Alexey Krylov
 * @see AbstractMVPApplicationModule#isJsr250SupportEnabled()
 * @since 04.03.13
 */
public class Jsr250Module extends AbstractModule {

    /*===========================================[ CLASS METHODS ]================*/

    @Override
    protected void configure() {
        install(Jsr250.newJsr250Module());
    }
}